
/*
	gbook-secure: to secure guestbook config file
 
	Users need to run this program before they 
	want to use guestbook CGI.

*/

#include "rogbook.h"

int main(int argc, char *argv[])
{
	char		home[80], gbk_path[80], gbk_conf[80];
	uid_t 		uid, euid;
	gid_t		httpd_gid;
	struct passwd   *pw;
	struct group	*grp;
	struct stat	sb;


	if ((euid = geteuid()) != 0) {
		printf("error: this program should be owned by root and setuid\n");
		
		exit(1);
	} else {

		uid = getuid();
		if (!(pw = getpwuid(uid))) {
			printf("error: getpw fail\n");
			exit(1);
		}
		if (!(grp = getgrnam(HTTPD_GRP))) {
			printf("error: can not get group id for %s\n", HTTPD_GRP);
			exit(1);
		}
		httpd_gid = grp->gr_gid;
		strncpy(home, pw->pw_dir, 80);
		strncpy(gbk_path, home, 80);
		strncat(gbk_path, "/", 80);
		strncat(gbk_path, GBOOK_DIR, 80);
		strncpy(gbk_conf, gbk_path, 80);
		strncat(gbk_conf, GBOOK_CONF, 80);
		lstat(gbk_conf, &sb);
		if ((sb.st_mode & 0777000) != S_IFREG) {
			printf("error: your %s is not a regular file\n", gbk_conf);
			exit(1);
		}

		/* setuid 0 */

		if (setuid(0) != 0) {
			printf("error: setuid 0 fail\n");
			exit(1);
		} else {
			chown(gbk_conf, uid, httpd_gid);
			chmod(gbk_conf, 0770);
		}
	}

	return 0;
}
