/*
 * GuestBook CGI 
 */

#include "rogbook.h"

/* Constants */
#define GBOOK_LIST "list"
#define GBOOK_READ "read"
#define GBOOK_EDIT "edit"
#define GBOOK_POST "post"
#define GBOOK_ADMIN "admin"
#define GBOOK_DELETE "delete"
#define GBOOK_SETUP "setup"
#define GBOOK_SEARCH "search"

/** Template files ***/
#define LIST_FILE "glist"
#define READ_FILE "gread"
#define EDIT_FILE "gedit"
#define ADMIN_FILE "gadmin"

/* Global Variables */
char		home_path[80], talk_path[80], gbook_path[80];
char		fdir[80], gbook_conf[80],title[80],proc[32];
char		user[32],msgbuf[80], linebuf[512], msgsubj[80], msgbody[MAX_MSG_SIZE];
time_t		now;
struct msgDIR	msgdir;
struct stat	st;
struct passwd  *pw;
char password[17];
char rowcolor[2][16]={"BGCOLOR=#fff7ee","BGCOLOR=#ffeedd"};
int reply=0,msgno;

/* ---------------------------- */
/* new/old/lock file processing */
/* ---------------------------- */

typedef struct
{
  char newfn[128];
  char oldfn[128];
  char lockfn[128];
}      nol;


int cgiError(char *errmsg)
{
	cgiHeaderContentType("text/html");
	fprintf(cgiOut, "<html><head><title>CGI Error</title></head><body>");
	fprintf(cgiOut, "<h2>CGI Error</h2><hr>");
	fprintf(cgiOut, "<h3>%s</h3>", errmsg);
	fprintf(cgiOut, "</body></html>");

	return 0;
}

int cgiBP(char *msg)
{
	cgiError(msg);
	exit(1);
}

int gbook_list();
int gbook_search();
int gbook_edit();
int gbook_post();
int gbook_read();
int gbook_admin();
int gbook_delete();
int gbook_setup();
int g_list();
int g_search();
int g_edit();
int g_read();
int g_admin();
int SSI(int ptmode);
int showout(char *filename);
int delete_record(char *fpath, int size, int id);

/*
 *---------------------------------------------------------------------
 * Guestbook: Main Program
 *---------------------------------------------------------------------
 */

int cgiMain()
{
	char  server[80], buf[32];
	FILE	*fp;
	int len;

	if (cgiFormString("user", user, 32) != cgiFormSuccess) {
		if (strlen(cgiQueryString) > 0) {
			strncpy(user, cgiQueryString, 32);
		} else {
			if (cgiServerName) {
				strncpy(server, cgiServerName, 80);
			} else {
				strncpy(server, "your_cgi_server", 80);
			}
			sprintf(msgbuf, "Read Only gbook usage: http://%s/cgi-bin/rogbook.cgi?someone's_account_name", server);
			cgiError(msgbuf);
			exit(1);
		}
	}

	/* initialization */
	if ((pw = getpwnam(user)) != NULL) {
		strncpy(home_path, pw->pw_dir, 80);
	} else {
		sprintf(msgbuf, "Can not find user %s on this host", user);
		cgiError(msgbuf);
		exit(1); 
	}

	sprintf(talk_path, "%s/%s%s", home_path,  GBOOK_DIR, TALK_DIR);
	sprintf(gbook_path, "%s/%s", home_path,  GBOOK_DIR);
	sprintf(fdir, "%s/%s%s%s", home_path, GBOOK_DIR, TALK_DIR, MSGDIR_RECORD);
	sprintf(gbook_conf, "%s/%s%s", home_path, GBOOK_DIR, GBOOK_CONF);

	/* get the title of guestbook */
	if ((fp = fopen(gbook_conf, "r")) != NULL) {
		fgets(title, 80, fp);
		fgets(buf, 32, fp);
		fgets(password, 16, fp);
		fclose(fp);
		len = strlen(title);
		if (len > 0) {
			if (title[len - 1] == '\n') {
				title[len - 1] = '\0';
			}
		} else {
			strncpy(title, user, 80);
		}
		MPP=atoi(buf);
		if ((MPP<1) || (MPP>500)) MPP=20;
		len = strlen(password);
		if (len > 0) {
                        if (password[len - 1] == '\n') {
                                password[len - 1] = '\0';
                        }
                } else {
                        strcpy(password, "KMUfhl");
                }
	} else { /* default title is user name */
		strncpy(title, user, 80);
	}

	if (cgiFormString("proc", proc, 16) != cgiFormSuccess) {
	   	strcpy(proc,"list");
		gbook_list();
		return 0;
	}

	if (strncmp(proc, GBOOK_LIST, 40) == 0) {
		gbook_list();
	} else if (strncmp(proc, GBOOK_READ, 40) == 0) {
	   	strcpy(proc,"list");
		gbook_read();
	} else if (strncmp(proc, GBOOK_EDIT, 40) == 0) {
	   	strcpy(proc,"list");
		gbook_edit();
	} else if (strncmp(proc, GBOOK_POST, 40) == 0) {
	   	strcpy(proc,"list");
		gbook_post();
    } else if (strncmp(proc, GBOOK_ADMIN, 40) == 0) {
		gbook_admin();
	} else if (strncmp(proc, GBOOK_DELETE, 40) == 0) {
	   	strcpy(proc,"list");
		gbook_delete();
	} else if (strncmp(proc, GBOOK_SEARCH, 40) == 0) {
	   	strcpy(proc,"search");
		gbook_search();
	} else if (strncmp(proc, GBOOK_SETUP, 40) == 0) {
	   	strcpy(proc,"list");
		gbook_setup();
	} else {
		sprintf(msgbuf, "CGI gbook has no such function: %s", proc);
		cgiError(msgbuf);
		exit(1);
	}

	return 0;
}
/*
 *---------------------------------------------------------------------
 *	Guestbook: Setup
 *---------------------------------------------------------------------
 */
int gbook_setup()
{
 char buf[17];
 char newtitle[80],newpwd1[17],newpwd2[17];
 int newMPP;
 FILE *fp;
    cgiHeaderContentType("text/html");
    cgiFormStringNoNewlines("password",buf,16);
        if (strcmp(password,buf)) {
                fprintf(cgiOut,"<h2>KX~I</h2>");
	fprintf(cgiOut, "<center><a href=\"%s?user=%s&proc=admin\">ЫB^޲ze</a></center>", CGI_SCRIPT, user);
                return 0;
        }
    /****** Ѽ *******/
    cgiFormStringNoNewlines("newpass1",newpwd1,16);
    cgiFormStringNoNewlines("newpass2",newpwd2,16);
        if (strcmp(newpwd1,newpwd2)) {
                fprintf(cgiOut,"<h2>sKX@P!</h2>");
	fprintf(cgiOut, "<center><a href=\"%s?user=%s&proc=admin\">ЫB^޲ze</a></center>", CGI_SCRIPT, user);
                return 0;
        }
	if (newpwd1[0]==0)
            strcpy(newpwd1,password);
    cgiFormStringNoNewlines("newTITLE",newtitle,79);
	if (newtitle[0]==0)
            strcpy(newtitle,title);
    cgiFormInteger("newMPP", &newMPP, 0);
	if (newMPP==0) newMPP=MPP;
    if ((MPP<1) || (MPP>500)) 
    	{MPP=20;
	 fprintf(cgiOut,"<h2>CgƳ]wȤb1P500AN]w20I</h2>");
	}
	/* get the title of guestbook */
       if ((fp = fopen(gbook_conf, "w")) != NULL) {
	fprintf(fp,"%s\n%d\n%s\n",newtitle,newMPP,newpwd1);
	fclose(fp);
	}
	else{
              fprintf(cgiOut,"<h2>%sɮ׶}ҿ~I</h2>",gbook_conf);
	fprintf(cgiOut, "<center><a href=\"%s?user=%s&proc=admin\">ЫB^޲ze</a></center>", CGI_SCRIPT, user);
                return 0;
        }
	fprintf(cgiOut,"ק粒<br>\n");
	fprintf(cgiOut, "<center><a href=\"%s?user=%s&proc=admin\">ЫB^޲ze</a></center>", CGI_SCRIPT, user);
}
/*
 *---------------------------------------------------------------------
 *	Guestbook: Admin
 *---------------------------------------------------------------------
 */
int gbook_admin()
{
    cgiHeaderContentType("text/html");
    showout(ADMIN_FILE);
}
int g_admin()
{
	char	date[40];
	int	msg1no, npost, fd, i,j;
	
		
	/* get the total number of messages */
	if (stat(fdir, &st) >= 0) {
		npost = st.st_size / sizeof(struct msgDIR);
	} else {
		npost = 0;
	}

	/* get the No. of the first message if given */
	cgiFormInteger("msg1no", &msg1no, npost);

	if (msg1no > npost || msg1no <= 0) {
		msg1no = 1;
	}

	if (npost > 0) {
		if ((fd = open(fdir, O_RDONLY)) != -1) {
		    j=1;
		    fprintf(cgiOut,"<form method=\"POST\" action=\"%s\">\n"
		    "<input type=\"hidden\" name=\"user\" value=\"%s\">"
		    "<input type=\"hidden\" name=\"proc\" value=\"delete\">",CGI_SCRIPT,user);
			for (i = msg1no; i >= 1 && i > (msg1no - MPP); i--) {
			lseek(fd, sizeof(struct msgDIR) * (i - 1), SEEK_SET);
				read(fd, &msgdir, sizeof(msgdir));
				strncpy(date, ctime(&msgdir.ptime) + 4, 6);
				date[6] = '\0';
				fprintf(cgiOut, "<tr %s><td><input name=\"m%d\" type=\"checkbox\" value=\"%d\">"
				 "<td  align=center>%d<td>%s<td>%s", 
				rowcolor[i%2],j++,i,i, date, msgdir.owner);
				fprintf(cgiOut, "<td><a href=\"%s?user=%s&proc=read&msgno=%d\">%s</a></tr>", 
				CGI_SCRIPT, user, i, msgdir.subj);
			}
			close(fd);
		}
		fprintf(cgiOut, "</table>");
		fprintf(cgiOut,"пJ޲zKXG<input type=\"password\" name=\"password\" size=17>");
		fprintf(cgiOut,"<input type=\"submit\" name=\"S2\" value=\"R峹\"></form>");
		fprintf(cgiOut, "</font>");
	} else {
		fprintf(cgiOut, "<p>&nbsp;<h3>|iKi</h3><p>&nbsp;");
	}

	return 0;
}

int gbook_delete()
{
	int i,killnum;
	char buf[17],chk[6];

	cgiHeaderContentType("text/html");
	cgiFormStringNoNewlines("password",buf,16); 
	if (strcmp(password,buf)) {
                fprintf(cgiOut,"<h2>KX~I</h2>");
	fprintf(cgiOut, "<center><a href=\"%s?user=%s&proc=admin\">ЫB^޲ze</a></center>", CGI_SCRIPT, user);
		return 0;
 	}

	/*** Ѽ ****/
	for (i = 1;i <= MPP; i++) {
		sprintf(buf,"m%d", i);
		cgiFormStringNoNewlines(buf,chk,5); 
    		killnum = atoi(chk);
    		//fprintf(cgiOut,"%d chk=%s killnum=%d||",i,chk,killnum);
    		if (killnum) {
            		delete_record(fdir, sizeof(struct msgDIR), killnum);
            		fprintf(cgiOut,"%dg峹<br>\n",killnum);
      		}
	}
	fprintf(cgiOut, "<td><a href=\"%s?user=%s&proc=admin\">ЫB^޲ze</a></tr>", CGI_SCRIPT, user);
    
}

/*
 *---------------------------------------------------------------------
 *	Guestbook:  SEARCH
 *---------------------------------------------------------------------
 */
int gbook_search()
{
    cgiHeaderContentType("text/html");
    showout(LIST_FILE);
}

int g_search()
{
	char	date[40];
	int	msg1no, npost, fd, i,founded=0;
	char    skey[128];
	
		
	/* get the total number of messages */
	if (stat(fdir, &st) >= 0) {
		npost = st.st_size / sizeof(struct msgDIR);
	} else {
		npost = 0;
	}

	/* get the No. of the first message if given */
	cgiFormInteger("msg1no", &msg1no, npost);
	/*** get search key ****/
        cgiFormString("key", skey,127);
	msg1no = npost;

	if (npost > 0) {
		/* show the list for messages */
		//fprintf(cgiOut, "<font size=4><table>");
		if ((fd = open(fdir, O_RDONLY)) != -1) {
			for (i = msg1no; i >= 1 ; i--) {
			lseek(fd, sizeof(struct msgDIR) * (i - 1), SEEK_SET);
				read(fd, &msgdir, sizeof(msgdir));
				strncpy(date, ctime(&msgdir.ptime) + 4, 6);
				date[6] = '\0';
			/****jMT~showX pݥ˯AХ[o****/
                                if ((strstr(msgdir.owner,skey))
                                   ||(is_file(msgdir.fn,skey))
                                   ||(strstr(msgdir.subj,skey)))
                                {

				  fprintf(cgiOut, "<tr %s><td  align=center>%d<td>%s<td>%s", rowcolor[i%2],i, date, msgdir.owner);
				  fprintf(cgiOut, "<td><a href=\"%s?user=%s&proc=read&msgno=%d\">%s</a></tr>", 
				  CGI_SCRIPT, user, i, msgdir.subj);
				  founded++;
			        }
			}
			close(fd);
		}
		fprintf(cgiOut, "</table>");
		fprintf(cgiOut, "</font>");
		if (founded==0)
                        fprintf(cgiOut, "<p>&nbsp;<h3>S%sI</h3><p>&nbsp;",skey);

	} else {
		fprintf(cgiOut, "<p>&nbsp;<h3>|LH</h3><p>&nbsp;");
	}

	return 0;
}

/*
 *---------------------------------------------------------------------
 *	Guestbook: List 
 *---------------------------------------------------------------------
 */
int gbook_list()
{
    cgiHeaderContentType("text/html");
    showout(LIST_FILE);
}

int g_list()
{
	char	date[40];
	int	msg1no, npost, fd, i;
	
		
	/* get the total number of messages */
	if (stat(fdir, &st) >= 0) {
		npost = st.st_size / sizeof(struct msgDIR);
	} else {
		npost = 0;
	}

	/* get the No. of the first message if given */
	cgiFormInteger("msg1no", &msg1no, npost);

	if (msg1no > npost || msg1no <= 0) {
		msg1no = 1;
	}

	if (npost > 0) {
		/* show the list for messages */
		//fprintf(cgiOut, "<font size=4><table>");
		if ((fd = open(fdir, O_RDONLY)) != -1) {
			//for (i = msg1no; i <= npost && i < (msg1no + MPP); i++) {
			for (i = msg1no; i >= 1 && i > (msg1no - MPP); i--) {
			lseek(fd, sizeof(struct msgDIR) * (i - 1), SEEK_SET);
				read(fd, &msgdir, sizeof(msgdir));
				strncpy(date, ctime(&msgdir.ptime) + 4, 6);
				date[6] = '\0';
				fprintf(cgiOut, "<tr %s><td  align=center>%d<td>%s<td>%s", rowcolor[i%2],i, date, msgdir.owner);
				fprintf(cgiOut, "<td><a href=\"%s?user=%s&proc=read&msgno=%d\">%s</a></tr>", 
				CGI_SCRIPT, user, i, msgdir.subj);
			}
			close(fd);
		}
		fprintf(cgiOut, "</table>");
		fprintf(cgiOut, "</font>");
	} else {
		fprintf(cgiOut, "<p>&nbsp;<h3>|LH</h3><p>&nbsp;");
	}

	return 0;
}

/*
 *---------------------------------------------------------------------
 *	Guestbook: Edit
 *---------------------------------------------------------------------
 */

  
int gbook_edit()
{
	FILE	*fp;
	char	type_str[40], title[80], msgfn[80];
	int	npost, fd ;

	/* reply or new */
	cgiFormString("type", type_str, 80);
	if (strncmp(type_str, "reply", 80) == 0) {
		strncpy(title, "^峹", 80);
		reply = 1;
	} else {
		strncpy(title, "o峹", 80);
	}

	/* initialization */
	msgsubj[0] = '\0';
	msgbody[0] = '\0';

	
	if (reply) {
		if (stat(fdir, &st) >= 0) {
			npost = st.st_size / (sizeof(struct msgDIR));
		} else {
			npost = 0;
		}

		if (cgiFormIntegerBounded("msgno", &msgno, 1, npost, npost) != cgiFormSuccess) {
			cgiError("relpy without message No.");
			exit(1);
		}

		if ((fd = open(fdir, O_RDONLY)) != -1) {
			lseek(fd, sizeof(msgdir) * (msgno - 1), SEEK_SET);
			read(fd, &msgdir, sizeof(msgdir));
			close(fd);
		} else {
			sprintf(msgbuf, "open file: %s failed", fdir);
			cgiError(msgbuf);
			exit(1);
		}

		if (strncmp(msgdir.subj, "^G", 6) == 0) {
			strncpy(msgsubj, msgdir.subj, 80);
		} else {
			sprintf(msgsubj, "^G%s", msgdir.subj);
		}

		sprintf(msgbody, " ޭzm%snʨG\n", msgdir.owner);
		sprintf(msgfn, "%s/%s%s%s", home_path, GBOOK_DIR, TALK_DIR, msgdir.fn);
		if ((fp = fopen(msgfn, "r")) != NULL) {
			while (fgets(linebuf + 2, 500, fp) != NULL) {
				linebuf[0] = ':';
				linebuf[1] = ' ';
				if ((linebuf[2]=='-')&&(linebuf[2]=='-')) break;
				if (strlen(linebuf + 2) > 3) {
					strcat(msgbody, linebuf);
				}
			}
			fclose(fp);
		} else {
			sprintf(msgbuf, "Can not open file: %s to read", msgfn);
			cgiError(msgbuf);
			exit(1);
		}
	}
	cgiHeaderContentType("text/html");
    showout(EDIT_FILE);
	//fprintf(cgiOut, "<form method=\"POST\" action=\"%s\">", CGI_SCRIPT);
	//fprintf(cgiOut, "<table>");
	//fprintf(cgiOut, "<tr><td>zjW (@wn):<td><input type=\"text\" name=\"name\" size=20 maxlength=40></tr>");
	//fprintf(cgiOut, "<tr><td>D (@wn):<td><input type=\"text\" name=\"msgsubj\" size=40 maxlength=80 value=\"%s\"><tr>", msgsubj);
	//fprintf(cgiOut, "<tr><td>z email address<td><input type=\"text\" name=\"email\" size=40 maxlength=80></tr>");
	//fprintf(cgiOut, "<tr><td>z home page m<td><input type=\"text\" name=\"homepage\" size=60 maxlength=80 value=\"http://\">");

	//fprintf(cgiOut, "<tr><td>峹JϡG");
	//fprintf(cgiOut, "<td><textarea name=\"msgbody\" rows=10 cols=60 >%s</textarea></tr></table>", msgbody);

	/*********
	if (reply) {
		fprintf(cgiOut, "<input type=\"hidden\" name=\"type\" value=\"reply\">");
		fprintf(cgiOut, "<input type=\"hidden\" name=\"msgfn\" value=\"%s\">", msgdir.fn);
		fprintf(cgiOut, "<input type=\"hidden\" name=\"msgno\" value=\"%d\">", msgno);
	}

	fprintf(cgiOut, "<input type=\"hidden\" name=\"user\" value=\"%s\">", user);
	fprintf(cgiOut, "<input type=\"hidden\" name=\"proc\" value=\"post\">");
	fprintf(cgiOut, "<input type=\"submit\" name=\"submit\" value=\"oXh\">");
	fprintf(cgiOut, "<input type=\"reset\" value=\"M{\"></form>");
        ********/

	return 0;
}

/*
 *---------------------------------------------------------------------
 *	Guestbook: post 
 *---------------------------------------------------------------------
 */

int gbook_post()
{
	char	name[40], email[80], homepage[80], date[40],buf[20];
	char	msgfn[80], msgsubj[80], msgbody[MAX_MSG_SIZE];
	char genbuf[20];
	int	fd, npost, msgno, i;
	FILE	*fp;

	now = time(0);
	strncpy(date, ctime(&now), 40);
	date[strlen(date) - 1] = '\0';

        cgiFormStringNoNewlines("password",buf,16);
        if (strcmp(password,buf)) {
	       cgiHeaderContentType("text/html");
                fprintf(cgiOut,"<h2>KX~I</h2>");
        fprintf(cgiOut, "<center><a href=\"%s?user=%s&proc=list\">
ЫB^De</a></center>", CGI_SCRIPT, user);
                return 0;
        }

	if (cgiFormString("name", name, 40) != cgiFormSuccess) {
		cgiError("Please tell us who you are");
		exit(1);
	}

	if (cgiFormString("email", email, 80) != cgiFormSuccess) {
		email[0] = '\0';
	}

	if (cgiFormString("homepage", homepage, 80) != cgiFormSuccess) {
		homepage[0] = '\0';
	}

	if (cgiFormString("msgsubj", msgsubj, 80) != cgiFormSuccess) {
		cgiError("Please give the subject for this messages");
		exit(1);
	}

	if (cgiFormString("msgbody", msgbody, MAX_MSG_SIZE) != cgiFormSuccess) {
		cgiError("Message Body is empty");
		exit(1);
	}
	
	strncpy(msgdir.owner, name, 40);
	strncpy(msgdir.subj, msgsubj, 80);
	strncpy(msgdir.host,cgiRemoteHost,40);
    	if (msgdir.host[0]==0)
      		strncpy(msgdir.host,cgiRemoteAddr,40);
	msgdir.host[39]=0;
	sprintf(msgdir.fn, "M.%d.A", (int) now);
	sprintf(msgfn, "%s/%s%sM.%d.A", home_path, GBOOK_DIR, TALK_DIR, (int) now);
	msgdir.ptime = now;
	strcpy(msgdir.url,homepage);
	strcpy(msgdir.email,email);
	for (i=0;i<=9;i++)
	{
	    sprintf(genbuf,"O%d",i+1);
	    if (cgiFormInteger(genbuf, &(msgdir.item[i]), 0)  != cgiFormSuccess) {
	        msgdir.item[i]=0;
	    }
	}

	if ((fd = open(fdir, O_RDWR | O_CREAT, 0666)) == -1) {
		sprintf(msgbuf, "Can not open file: %s", fdir);
		cgiError(msgbuf);
		exit(1);
	}

	if (stat(fdir, &st) >= 0) {
		npost = st.st_size / sizeof(struct msgDIR);
	} else {
		npost = 0;
	}

	if ((msgno < 0) || (msgno > npost)) {
		cgiError("msgno is over range");
		exit(1);
	}

	if (lseek(fd, sizeof(struct msgDIR) * npost, SEEK_SET) == -1) {
		close(fd);
		sprintf(msgbuf, "lseek file: %s failed", fdir);
		cgiError(msgbuf);
		exit(1);
	}

	write(fd, &msgdir, sizeof(msgdir));

	close(fd);

	/* write message body */
	if ((fp = fopen(msgfn, "w")) != NULL) {
		fputs(msgbody, fp);
		/*****
		if (strlen(email) > 0) {
			fprintf(fp, "\n\n\n\n\n----------\n@ email-address: <a href=\"mailto:%s\">%s</a> | ", email, email);
		}
		if (strlen(homepage) > 0) {
			fprintf(fp, "@ homepage: <a href=\"%s\">%s</a>\n", homepage, homepage);
		}
		*******/
		fclose(fp);
	} else {
		sprintf(msgbuf, "write file: %s failed", msgfn);
		cgiError(msgbuf);
		exit(1);
	}
	sprintf(homepage,"%s?user=%s&proc=list&msg1no=%d",CGI_SCRIPT,user,npost+1);
	cgiHeaderContentType("text/html");
	fprintf(cgiOut,"<script LANGUAGE=\"JavaScript\" FOR=\"window\" "
        "EVENT=\"onload()\">\n"
            "<!--\n"
        "window.location=\"%s\""
            "\n//-->\n</script>\n",homepage);
        //cgiHeaderLocation(homepage);
	//gbook_list(user);

	return 0;
}

/*
 *---------------------------------------------------------------------
 *	Guestbook: Read
 *---------------------------------------------------------------------
 */

int gbook_read()
{
	int	fd, npost;
	char	subject[80] /*, msgfn[80]*/;
	//FILE	*fp;

	if (cgiFormInteger("msgno", &msgno, 0) != cgiFormSuccess) {
		cgiError("no message No.");
		exit(1);
	}

	if (stat(fdir, &st) >= 0) {
		npost = st.st_size / sizeof(struct msgDIR);
	} else {
		npost = 0;
	}

	if (msgno > npost) msgno = npost;
	if (msgno <= 0) msgno = 1;

	if ((fd = open(fdir, O_RDONLY)) != -1) {
		lseek(fd, sizeof(msgdir) * (msgno - 1), SEEK_SET);
		read(fd, &msgdir, sizeof(msgdir));
		close(fd);
	} else {
		sprintf(msgbuf, "Can not open file: %s to read", fdir);
		cgiError(msgbuf);
		exit(1);
	}

	if (strncmp("^G", msgdir.subj, 6) != 0) {
		strcpy(subject, msgdir.subj);
	} else {
		strcpy(subject, msgdir.subj + 6);
	}

	cgiHeaderContentType("text/html");
	showout(READ_FILE);
	

	return 0;
}

int showout(char *filename)
{
    FILE *fptr;
    char buf[256],oneline[300];
    char *pt1,*pt2;
    int ptmode;

/********* }YɡApGSYɡANۤvdefaultX ***/
     
   sprintf(buf, "%s%s",gbook_path,filename);
   if( (fptr = fopen(buf,"r")) == NULL )
   {
    fprintf(cgiOut,"%sɮ׶}ҿ~<br>",buf);
     return 0;
      
   }
    /*LXYAĤGiH令LXҪɮ **/
   while(fgets(oneline, 300, fptr) != NULL)  
   {
      pt1=oneline;
      while (pt2=strstr(pt1,"<!--$"))
      {
         *pt2=0;
         pt2=pt2+5;
         fprintf(cgiOut,"%s", pt1);/* LXtokener */
         pt1=strstr(pt2,"-->");
         if (pt1==NULL) 
         {
            fprintf(cgiOut,"榡ɿ~IP@椺䤣 -->");
            return 0;
         }
         *pt1=0;
         pt1=pt1+3;
         ptmode=atoi(pt2);
         if (ptmode==0) //Dn\
         {
               
         } //Dn\
        else // other mode
            SSI(ptmode);
     } //while <!--$
     fprintf(cgiOut,"%s", pt1);
   } // while get oneline
      fclose(fptr);
}

/***** SSI for uX***/
int SSI(int ptmode)
{
   FILE *fp;
   char linebuf[512],msgfn[128];
   int npost,msg1no;
    switch (ptmode)
    {
      /*** LIST D ID ****/
      case 1 : 
		if (strcmp(proc, GBOOK_SEARCH)!=0)
                        g_list();
                else
                        {
                                g_search();
                                strcpy(proc, GBOOK_LIST);
                        }
                        break;
      /**** CGIWr ***/
      case 2 : fprintf(cgiOut,"%s",CGI_SCRIPT); break;
      /****峹D **/
      case 3 : fprintf(cgiOut,"%s",msgdir.subj); break;
      /*** 峹@ ***/
      case 4 : fprintf(cgiOut, "%s", msgdir.owner);break;
      /*** 峹ɶ ***/
      case 5 : fprintf(cgiOut, "%s", ctime(&msgdir.ptime));break;
      /*** 峹e **/
      case 6:
        sprintf(msgfn, "%s%s", talk_path, msgdir.fn); 
	    if ((fp = fopen(msgfn, "r")) != NULL) {
	        while (fgets(linebuf, 511, fp) != NULL)
			    fprintf(cgiOut, "%s<br>\n", linebuf);
	    fclose(fp);
	    }
	    else {
		    sprintf(msgbuf, "Can not open file: %s", msgfn);
		    cgiError(msgbuf);
		    exit(1);
	    }
	  break;
	  /**** EditɪwD ***/
  	case 7 : fprintf(cgiOut, "%s", msgsubj);break;
	  /**** Editɪwe ***/
  	case 8 : fprintf(cgiOut, "%s", msgbody);break;
	  /**** Owner Email ***/
 	case 9 : fprintf(cgiOut,"%s",msgdir.email); break;
	  /**** Owner URL ***/
	case 10 : fprintf(cgiOut,"%s",msgdir.url); break;
	  /**** owner ﶵ ***/
	case 11 :
	case 12 :
	case 13 :
	case 14 :
	case 15 :
	case 16 :
	case 17 :
	case 18 :
	case 19 :
	case 20 : 
	        fprintf(cgiOut,"%d",msgdir.item[ptmode-11]); break;
      /**** dҦID ***/
      case 21 : fprintf(cgiOut,"%s",user); break;
      /**** `@Xhd ***/
      case 22 : 
	if (stat(fdir, &st) >= 0) {
              npost = st.st_size / sizeof(struct msgDIR);
       	} else {
        npost = 0;
       	}
	fprintf(cgiOut,"%d",npost); break;
      /**** ثeds ***/
      case 23 : 
	if (stat(fdir, &st) >= 0) {
              npost = st.st_size / sizeof(struct msgDIR);
       	} else {
        npost = 0;
       	}
	cgiFormInteger("msg1no", &msg1no, npost);
	fprintf(cgiOut,"%d",msg1no); break;
	/***** U@ ******/
     case 24:
	if (stat(fdir, &st) >= 0) {
              npost = st.st_size / sizeof(struct msgDIR);
       	} else {
        npost = 0;
       	}
	cgiFormInteger("msg1no", &msg1no, npost);
	if (msg1no > MPP) {
		fprintf(cgiOut, "<a href=\"%s?user=%s&proc=%s&msg1no=%d\">", CGI_SCRIPT, user, proc,msg1no - MPP);
	}
	else
		fprintf(cgiOut, "<a href=\"%s?user=%s&proc=%s&msg1no=%d\">", CGI_SCRIPT, user,proc, msg1no);
	break;
     /**** W@ ****/
     case 25:
	if (stat(fdir, &st) >= 0) {
              npost = st.st_size / sizeof(struct msgDIR);
       	} else {
        npost = 0;
       	}
	cgiFormInteger("msg1no", &msg1no, npost);
	if (npost > (msg1no + MPP - 1)) {
		fprintf(cgiOut, "<a href=\"%s?user=%s&proc=%s&msg1no=%d\">", CGI_SCRIPT, user, proc,msg1no + MPP);
	}
	else
		fprintf(cgiOut, "<a href=\"%s?user=%s&proc=%s&msg1no=%d\">", CGI_SCRIPT, user,proc, npost);
	break;
	
	/**** ̫@ ****/
     case 26:
	if (stat(fdir, &st) >= 0) {
              npost = st.st_size / sizeof(struct msgDIR);
       	} else {
        npost = 0;
       	}
	if (npost<MPP)
		fprintf(cgiOut, "<a href=\"%s?user=%s&proc=%s&msg1no=%d\">",
	CGI_SCRIPT,user,proc,npost);
	else
		fprintf(cgiOut, "<a href=\"%s?user=%s&proc=%s&msg1no=%d\">",
	CGI_SCRIPT,user,proc,MPP);
	break;
     /***** EDITɻݭn\J@ø *****/
    case 27:
	if (reply) {
		fprintf(cgiOut, "<input type=\"hidden\" name=\"type\" value=\"reply\">");
		fprintf(cgiOut, "<input type=\"hidden\" name=\"msgfn\" value=\"%s\">", msgdir.fn);
		fprintf(cgiOut, "<input type=\"hidden\" name=\"msgno\" value=\"%d\">", msgno);
	}

	fprintf(cgiOut, "<input type=\"hidden\" name=\"user\" value=\"%s\">", user);
	fprintf(cgiOut, "<input type=\"hidden\" name=\"proc\" value=\"post\">");
	break;
     /***** READɻݭn\J@ø ΨӦ^峹*****/
    case 28:
		fprintf(cgiOut, "<form method=\"POST\" action=\"%s\">", CGI_SCRIPT);
		fprintf(cgiOut, "<input type=\"hidden\" name=\"user\" value=%s>", user);
		fprintf(cgiOut, "<input type=\"hidden\" name=\"proc\" value=edit>");
		fprintf(cgiOut, "<input type=\"hidden\" name=\"msgno\" value=%d>", msgno);
		fprintf(cgiOut, "<input type=\"hidden\" name=\"type\" value=reply>");
		fprintf(cgiOut, "<input type=\"submit\" name=\"submit\" value=\"^峹\"></form>");
		break;
	/***************ΨӲͤU@峹s *****/
    case 29:
		if (msgno > 1)  
			fprintf(cgiOut, "%d",  msgno - 1);
		else
			fprintf(cgiOut,"1");
		break;
	/********* ΨӲͤW@峹s ***/	
    case 30:
	if (stat(fdir, &st) >= 0) {
              npost = st.st_size / sizeof(struct msgDIR);
       	} else {
        npost = 0;
       	}
		if (msgno < npost) 
			fprintf(cgiOut, "%d",msgno + 1);
		else
			fprintf(cgiOut,"%d",npost);
		break;
	/********* ΨӲͤW@峹s ***/	
    case 31:
	fprintf(cgiOut, "%d",msgno);
	break;
	/********* ΨӦCLXdD ***/	
    case 32:
	fprintf(cgiOut, "%s",title);
	break;
	/********* ΨӦLXC峹g ***/	
    case 33:
	fprintf(cgiOut, "%d",MPP);
	break;
	/********* ΨӦLX峹@IP ***/	
    case 34:
	fprintf(cgiOut, "%s",msgdir.host);
	break;
	/***** ΨӰtα ****/
	case 35 : g_admin();break;
    }//switch
}

/* Cg@IIAHw */

int safewrite(int fd, char *buf, int size)
{
  int cc, sz = size, origsz = size;
  char *bp = buf;
  do
  {
    cc = write(fd, bp, sz);
    if ((cc < 0))
    {
      fprintf(cgiOut,"safewrite failed!");
      return -1;
    }
    if (cc > 0)
    {
      bp += cc;
      sz -= cc;
    }
  } while (sz > 0);
  return origsz;
}



int delete_record(char *fpath, int size, int id)
{
  char abuf[512],msgfn[128];
  int fdr, fdw, fd;
  int count;
  nol my;
  struct msgDIR *recpt;

  sprintf(my.newfn, "%s.new", fpath);
  sprintf(my.oldfn, "%s.old", fpath);
  sprintf(my.lockfn, "%s.lock", fpath);

  if ((fd = open(my.lockfn, O_RDWR | O_CREAT | O_APPEND, 0644)) == -1)
    return -1;
  flock(fd, LOCK_EX);

  if ((fdr = open(fpath, O_RDONLY, 0)) == -1)
  {

    fprintf(cgiOut,"delete_record failed!!! (open)");
    flock(fd, LOCK_UN);
    close(fd);
    return -1;
  }
  if ((fdw = open(my.newfn, O_WRONLY | O_CREAT | O_EXCL, 0644)) == -1)
  {
    flock(fd, LOCK_UN);

    fprintf(cgiOut,"delete_record failed!!! (open tmpfile)");

    close(fd);
    close(fdr);
    return -1;
  }
  //fprintf(cgiOut,"%s,,%s,,%s",my.newfn,my.oldfn,my.lockfn);
  count = 1;
  while (read(fdr, abuf, size) == size)
  {
    if (id != count++ && (safewrite(fdw, abuf, size) == -1))
    {

      fprintf(cgiOut,"delete_record failed!!! (safewrite)");
      unlink(my.newfn);
      close(fdr);
      close(fdw);
      flock(fd, LOCK_UN);
      close(fd);
      return -1;
    }
    else
    {
	if (id==count-1)
        {
	  recpt=abuf;
	  //fprintf(cgiOut,"||%s<br>||",recpt->fn);
	  sprintf(msgfn, "%s/%s%s%s", home_path, GBOOK_DIR, TALK_DIR,recpt->fn);
	  unlink(msgfn);//峹աI 
	}
    }
  }
  close(fdr);
  close(fdw);
  if (rename(fpath, my.oldfn) == -1 || rename(my.newfn, fpath) == -1)
  {
    fprintf(cgiOut,"delete_record failed!!! (Rename)");
    flock(fd, LOCK_UN);
    close(fd);
    return -1;
  }
  flock(fd, LOCK_UN);
  close(fd);
  return 0;
}
/********************************
   ˬdɮפO_X{Ӧr
***********************************/
int is_file(char *filename,char *key)
{
 char linbuf[512],msgfn[128];
 int flag=0;
 FILE *fp;
        sprintf(msgfn, "%s%s", talk_path, filename);
        if ((fp = fopen(msgfn, "r")) != NULL) {
                while ((fgets(linbuf, 511, fp) != NULL)&&(flag==0))
                        if (strstr(linbuf,key)) flag=1;
            fclose(fp);
            }
            else {
                    sprintf(msgbuf, "Can not open file: %s", filename);
                    cgiError(msgbuf);
                    exit(1);
            }
  return flag;

}
